
/* getfunctions
   861127
*/

/* some of these includes may not be needed */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <types.h>
#include <stat.h>
#include <io.h>
#include <ctype.h>
#include <string.h>
#include <math.h>


/* Tempbuf is a global buffer of course you know this */

char Tempbuf[256];

/* fill Tempbuf with (s) of specified character (c)
   and NULL terminate it
*/

char *replicate(c,s)
char c;
int s;
{
   int n;

   for (n=0;n<s;n++)
      Tempbuf[n] = c;

   Tempbuf[s] = NULL;

   return(Tempbuf);

}

/* fill Tempbuf with (s) spaces */

char *space(s)
int s;
{

   return(replicate(' ',s));

}

/* a crude substring function */

char *strsub(s, p, n)
char *s;
int p,n;
{

   int i = 0;

   /* what about null str ? */

   strcpy(Tempbuf,s);

   p-= 1;

   while (i <= n-1)
      Tempbuf[i++] = s[p++];

   Tempbuf[i] = NULL;

   return(Tempbuf);

}

/* crude string trimmer */

char *strtrm(xstr)
char *xstr;
{
   int s;

   strcpy(Tempbuf,xstr);

   s = strlen(xstr)-1;

   while (Tempbuf[s] == ' ' && s >= 0)
      Tempbuf[s--] = NULL;

   return(Tempbuf);

}


/* you may want to do away with this and in getxxx */

getchr()
{

   return(getch());

}

/* you may want to do away with this and in getxxx */

void putchr(c,a)
char c;
int a;
{

   /* you'll need to replace with a put character,attribute function */

   putca(c,a);

}

void setcur(x,y)
int x,y;
{
   /* you'll need a cursor positioning function */

   curspos(x,y);
}

void say(x,y,str)
int x,y;
char *str;
{

   /* see above */

   putcsa(x+1,y+1,ATR0,str);
   setcur(x,y+strlen(str));

}

void asay(x,y,attr,str)
int x,y,attr;
char *str;
{
   /* see above */

   putcsa(x+1,y+1,attr,str);
   setcur(x,y+strlen(str));

}

/* these are globals for the get functions
   made them global to save parameter passing

   first character of picture defines them
   see doc !

  -stype tells if it is a string or a number
  -negok tells if it is ok to input a minus sign
  -confirm is set to force a carriage return on input
  -insert is a flag set or unset by pressing insert key
  -keyyet is to help formatting along

*/

int stype;
int negok;
int confirm = 0;
int insert  = 0;
int keyyet;

/* strip out format characters from string */

void strip(str)
char *str;
{

   int c,s;
   char buf[81];

   s = 0;

   for (c=0;str[c] != NULL;c++)
      if (str[c] != ',' && str[c] != ' ') {
         buf[s] = str[c];
         s++;
      }

   buf[s] = NULL;

   strcpy(str,buf);

}

/* move cursor variable left skipping format characters in string */

void yleft(plc,fmt)
int *plc;
char *fmt;
{
   while (strchr("ZXA9!", fmt[*plc]) == NULL && *plc > 0)
      *plc-=1;
}

/* move cursor variable right skipping format characters in string */

void yright(plc,fmt)
int *plc;
char *fmt;
{
   while (strchr("ZXA9!", fmt[*plc]) == NULL &&  fmt[*plc] != NULL)
      *plc+=1;

   if (fmt[*plc] == NULL)
      *plc-=1;

}

/* is it ok to input a minus sign at current cursor position ? */

dashok(chr,plc,buf)
char chr;
int plc;
char *buf;
{

      int c;
      char buf1[81];

      for (c=0;buf[c] != NULL;c++)
         if (buf[c] == '-' && chr == '-' && !stype)
            return(0);

      strcpy(buf1,buf);
      strcpy(buf1,strsub(buf1,1,plc));
      strcpy(buf1,strtrm(buf1));

      c = strlen(buf1);

      return (chr == '-' && !stype && c == 0 && negok) ? 1 : 0;

}

/* is key pressed ok for current picture character ? */

keyok(chr,fmt)
char chr,fmt;
{

   return ( (fmt == '9' && (isdigit(chr) || chr == ' ')) ||
            (fmt == 'A' && (isalpha(chr) || chr == ' ')) ||
            (fmt == 'Z' || fmt == 'X'    || fmt == '!') )
            ? 1 : 0;

}

/* pull right characters over to left after del key pressed */

void pullrt(plc,str)
int plc;
char *str;
{

   strcpy(Tempbuf,str);

   str[plc] = NULL;

   strcat(str,&Tempbuf[plc+1]);

   str[strlen(str)] = ' ';

}

/* push characters right of cursor after key press and insert in on */

void pushrt(str,c,plc)
char *str;
char c;
int plc;
{

   strcpy(Tempbuf,str);

   if (strlen(Tempbuf) > 0)
      Tempbuf[strlen(Tempbuf)-1] = NULL;
   else
      Tempbuf[0] = NULL;

   str[plc] = NULL;

   sprintf(str,"%s%c%s",str,c,&Tempbuf[plc]);

}

/* cleanup string to convert to double */

void cleanup(str)
char *str;
{
   int c;

   for (c=0;str[c] != NULL;c++)
      if (str[c] == ',' && c>0 && !isdigit(str[c-1]))
         str[c] = ' ';

}

/* format the clean string to conform to picture string */

void format(buf,fmt,str)
char *buf,*fmt,*str;
{
   int l;
   int f,s,m;

   f = 0;
   s = 0;

   l = strlen(fmt);

   strcpy(buf,space(l));

   while (f <= l) {

      if (strchr("ZXA9!",fmt[f]) != NULL) {

         while (!keyok(str[s],fmt[f]) && str[s] != NULL)
            if (str[s] == '-' && !stype)
               break;
            else
               s++;

/* caps problem is here ... */

         if (str[s] != NULL) {
            if (fmt[f] == '!')
               str[s] = toupper(str[s]);
            else if ( fmt[f] == 'Z' &&
               ((s > 0 && str[s-1] == ' ') || s == 0) )
               str[s] = toupper(str[s]);
            buf[f] = str[s];
            s++;
         }

      }
      else
         buf[f] = fmt[f];

      f++;

   }

   strcpy(str,buf);
   if (!stype)
      cleanup(buf);

}

/* find out where decimal place is in format string */

decpos(fmt)
char *fmt;
{

   int c,n;

   c = strlen(fmt);

   for (n=c;n>=0;n--)
      if (fmt[n] == '.')
         return(n);

   return(0);


}

/* find out how many extra spaces we need to be same length as picture */

extra(fmt)
char *fmt;
{

   int c,n;

   n = 0;

   for (c = 0;fmt[c] != NULL;c++)
      if (strchr("ZXA9!",fmt[c]) == NULL && fmt[c] != '.')
         n++;

   return(n);

}

/* calculate left and right of decimal spaces */

fmtnum(fmt)
char *fmt;
{

   int r,nm,nd;

   strcpy(Tempbuf,fmt);

   strip(Tempbuf);

   r = strlen(Tempbuf);
   nm = r - (r - decpos(Tempbuf))+1;
   nm+=extra(fmt);
   nd = r - decpos(Tempbuf) - 1;

   return((nm*10)+nd);

}

/* print a double into a string */

void nprint(buf,nm,nd,f)
char *buf;
int nm,nd;
double f;
{

   char fm[81];

   if (nd > 0)
      sprintf(fm,"%%%d.%dlf", nm,nd);
   else
      sprintf(fm,"%%%dlf", nm);

   sprintf(buf, fm, (double)f);

}

/* fix up string after decimal key is pressed then move
   cursor 1 postition past decimal
*/

void justify(buf,str,fmt,plc)
char *buf,*str,*fmt;
int *plc;
{

   int nm,nd;
   double f,d,s;
   char fm[81];

   nm = fmtnum(fmt);
   nd = nm%10;
   nm = (nm-nd)/10;
   nm +=nd;
   nm-=extra(fmt);

   strcpy(fm,str);
   strip(fm);
   s = (fm[0] == '-') ? -1L : 1L;

   strcpy(fm,strsub(str,1,*plc));
   strip(fm);
   f = (double)atof(fm);

   strcpy(fm,strsub(str,decpos(str)+1,nd+1));
   strip(fm);
   d = (double)atof(fm)*s;

   f+=d;

   nprint(buf,nm,nd,f);

   strcpy(str,buf);

   format(buf,fmt,str);

   *plc = 0;

   while (buf[*plc] != '.')
      *plc+=1;

   *plc+=1;

}

/* move cursor postion over spaces in string */

void spcskip(str,del,plc)
char *str;
int *del;
int plc;
{

   while(str[*del] == ' ' && *del >= plc)
      *del-=1;

}

/* fix up string from caller to buffer for get routines */

fmtfix(xstr,fmt,str)
char *xstr,*fmt,*str;
{
   int nm,nd,r;
   char buf1[81];

   strcpy(buf1,xstr);

   r = strlen(fmt);

   if (!stype) {
      strip(buf1);
      r = nm = fmtnum(fmt);

      nd = nm%10;
      nm = (nm-nd)/10;
      nm+=nd;
      nm-=extra(fmt);

      nprint(str,nm,nd,atof(buf1));


   }
   else  {
       if (r > strlen(buf1))
          sprintf(str,"%s%s",xstr,space(r-strlen(buf1)));
       else
          strcpy(str,strsub(buf1,1,r));
   }

   return(r);

}

/* tell if truncation causes accuracy error */

void valerr(str,xstr)
char *str,*xstr;
{
   char buf[81];

   if (!stype) {
      strcpy(buf,str);
      strip(buf);

      if ((atof(xstr) - atof(buf)) > 1L)
         /* you'll need screen output routine here
         if you want to know a value error occured */
         say(23,1,"\n error (1) getxxx.c ...");
   }

}

/* can't remember what this does */

char *numfmt(f,fmt)
double f;
char *fmt;
{

   int nm,nd;
   char str[81];

   stype = 0;

   nm = fmtnum(fmt);
   nd = nm%10;
   nm = (nm-nd)/10;
   nm+=nd;
   nm-=extra(fmt);

   nprint(str,nm,nd,f);

   format(Tempbuf,fmt,str);

   return(Tempbuf);

}

/* heres main get routine */
   call with row,column,format string, string you are inputing
   returns direction according to following

   pageup   = -10
   pagedown =  10
   uparrow  =  -1
   downarrow=   1
   return   =   1

getxxx(xx,yy,fmt,xstr)
int xx, yy;
char  *fmt, *xstr;
{

   int plc,del,ret,len;
   int att1,att2;
   int edit;
   char  chr;
   char str[81];
   char buf[81];

   att1    = (fmt[0] - '0' & 8) ? ATR1 : ATR0;
   att2    = (fmt[0] - '0' & 4) ? ATR1 : ATR0;
   negok   = (fmt[0] - '0' & 2) ? 1 : 0;

   fmt++;

   fmtfix(xstr,fmt,str);

   format(buf,fmt,str);

   valerr(str,xstr);

   del = len = strlen(fmt);

   str[len] = NULL;

   plc = 0;

   yright(&plc,fmt);

   ret = keyyet = 0;

   while (ret == 0) {

/*    edit = (plc > 0) ? 1 : 0;  */

      format(buf,fmt,str);

      /* replace with your own cursor positioning and screen
         output routines
         asay(row,column,attribute,pointer to string to output)
      */
      asay(xx,yy,att1,buf);

      /* replace with your own cursor positioning routine
         setcur(row,column)
      */
      setcur(xx, yy+plc);

      chr = getch();

      if (chr == 13) {
         if (!stype) {
            if (plc == 0 || plc == len-1 || !keyyet)
               plc = len;

            strcpy(str,strsub(str,1,plc));
            fmtfix(str,fmt,buf);
            strcpy(str,buf);
            format(buf,fmt,str);

         }
         ret = 1;
      }

      else if (chr == 0) {

         chr = getch();
         switch (chr)  {
              /* home key */
              case 'G':
                   plc = 0;
                   yright(&plc,fmt);
                   break;
              case 0x52:
              /* insert key */
                   insert = (insert) ? 0 : 1;
                   break;
              case 0x53:
              /* del key */
                   del = len - 1;
         /*        spcskip(str,&del,plc);  */
                   pullrt(plc,str);
                   break;
              case 0x73:
              /* control left arrow */
                   if (plc > 0) {
                       del = len - 1;
                       spcskip(str,&del,plc);
                       plc--;
                       yleft(&plc,fmt);
                   }
                   break;
              case 0x75:
              /* control end key */
                   fmtfix(xstr,fmt,str);
                   format(buf,fmt,str);
                   plc = 0;
                   yright(&plc,fmt);
                   keyyet = 0;
                   break;
              case 0x77:
              /* control home key */
                   plc = 0;
                   yright(&plc,fmt);
                   break;
              case 'H':
              /* up arrow key */
                   ret = -1;
                   break;
              case 'I':
              /* pageup key */
                   ret = -10;
                   break;
             case 'K':
             /* left arrow key */
                   if (plc > 0) {
                      plc--;
                      yleft(&plc,fmt);
                   }
                   else
                       ret = -1;
                   break;
              case 'M':
              /* right arrow key */
                   if (plc < (len - 1)) {
                      plc++;
                      yright(&plc,fmt);
                   }
                   else
                       ret = 1;
                   break;
              case 'O':
              /* end key */
                   plc = (len - 1);
                   yleft(&plc,fmt);
                   break;
              case 'P':
              /* down arrow key */
                   ret = 1;
                   break;
              case 'Q':
              /* page down key */
                   ret = 10;
                   break;
              case 60:
              /* f2 key */
                   confirm = (confirm) ? 0 : 1;
                   break;
           }
      }
      /* <- backspace key */
      else if (chr == 8 && plc > 0)  {
         plc--;
         yleft(&plc,fmt);
      }
      else if (chr == '.' && !stype && plc<decpos(fmt))
         justify(buf,str,fmt,&plc);

      else if (chr > 31 && plc < len && (dashok(chr,plc,buf)
         || keyok(chr,fmt[plc]))) {

         /* marker */
         if (chr !=' ')
            keyyet = 1;

         if (insert)
            pushrt(str,chr,plc);
         else if (!insert && fmt[plc] != ' ')
            str[plc] = chr;

         if (plc < (len - 1)) {
            plc++;
            yright(&plc,fmt);
         }
         else if (!confirm)
            ret = 1;

      }
      else
         /* illegal character for format picture */
         printf("%c", 7);

   }

   format(buf,fmt,str);

   if (!stype)
     strip(str);

   asay(xx,yy,att2,buf);

   /* this will pop up on screen if return string is longer than
      string passed
   */
   if (strlen(str) > strlen(xstr))
      /* another screen output replacement you'll need to do */
      say(23,1,"\n error (0) getxxx.c ...");

   strcpy(xstr,str);

   return(ret);

}

getdbl(xx,yy,fmt,f)
int xx,yy;
char *fmt;
double *f;
{

   int nm,nd;
   int ret,force;
   char buf[31];

   /* this ain't no string ! */

   stype = 0;

   force = (fmt[0] - '0' & 1) ? 1 : 0;

   nm = fmtnum(fmt+1);
   nd = nm%10;
   nm = (nm-nd)/10;
   nm+=nd;

   nprint(buf,nm,nd,*f);

   while (1) {

      ret = getxxx(xx,yy,fmt,buf);

      *f = (double)atof(buf);

      /* kind of crude but it works for me */

      if ((force && *f != 0L) || !force)
         return(ret);
   }


}

getstr(xx,yy,fmt,xstr)
int xx,yy;
char *fmt;
char *xstr;
{

   int ret,force;

   /* this better be a string ! */

   stype = 1;

   force = (fmt[0] - '0' & 1) ? 1 : 0;

   while (1) {

      ret = (getxxx(xx,yy,fmt,xstr));

      if ((force && strlen(strtrm(xstr)) > 0) || !force)
         return(ret);

   }

}


